package com.example.backend;

import java.util.ArrayList;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.PathVariable;



@SpringBootApplication
@RestController
@RequestMapping("/api")
public class BackendApplication {

	private ArrayList<TestDTO> list = new ArrayList<>();

	public static void main(String[] args) {
		SpringApplication.run(BackendApplication.class, args);
	}

	@GetMapping("/hello")
	public String get(@RequestParam(name = "name", defaultValue = "World!") String name){
		return String.format("Hello, %s", name);
	}

	@GetMapping()
	public ArrayList<TestDTO> getAll(){
		return list;
	}

	@GetMapping("/id") 
	public TestDTO getById(@RequestParam(name = "id") int id){
		return list.get(id); 
	}

	@PostMapping()
	public TestDTO postTestDTO(@RequestBody TestDTO testDTO) {
		list.add(testDTO);
		return testDTO;
	}

	@PutMapping("/{id}")
	public TestDTO updaTestDTO(@PathVariable(name = "id") int id, @RequestBody TestDTO entity) {
		list.add(id, entity);
		return entity;
	}
	

	@DeleteMapping("{id}")
	public TestDTO delMethod(@PathVariable(name = "id") int id){
		return list.remove(id);
	}		

}
